// DragBar.cpp

#include "stdafx.h"
#include "DragBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CDragBar, CWnd)
	//{{AFX_MSG_MAP(CDragBar)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_PAINT()
	ON_WM_CAPTURECHANGED()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDragBar::OnLButtonDblClk(UINT nFlags, CPoint point) {Move(Default);}

void CDragBar::OnLButtonDown(UINT nFlags, CPoint point) {
  Offset=point.x;
  Dragging=true;
}

void CDragBar::OnMouseMove(UINT nFlags, CPoint point) {
  ClientToScreen(&point); // Get the point in Owner's coords
  GetParent()->ScreenToClient(&point);
  CRect Rect; // Our bounds in Owner coords
  GetWindowRect(&Rect);
  GetParent()->ScreenToClient(&Rect);
  BOOL PtInRect=Rect.PtInRect(point);
  if(Captured || PtInRect) {
    if(!Captured) Capture();
    else if(Dragging) {
      CRect ClientRect;
      GetParent()->GetClientRect(&ClientRect);
      int t, dx=(point.x-Offset)-Rect.left;
           if((t=ClientRect.left -(Rect.left +dx))>-MinGap) dx+=t;
      else if((t=ClientRect.right-(Rect.right+dx))< MinGap) dx+=t;
      if(Live) Move(dx); // Move everything or...
      else{              // ...just move the DragBar:
        Rect.left +=dx;
        Rect.right+=dx;
        MoveWindow(&Rect);
      }
    }else if(!PtInRect) Release();
  }
  CWnd::OnMouseMove(nFlags, point);
}

void CDragBar::OnLButtonUp(UINT nFlags, CPoint point) {
  Finish();
  CWnd::OnLButtonUp(nFlags, point);
}

void CDragBar::Capture() {
  Cursor=::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEWE));
  SetCapture();
  Captured=true;
}

void CDragBar::Release() {
  Cursor=::SetCursor(Cursor);
  ReleaseCapture();
  Captured=false;
}

void CDragBar::Finish() {
  if(Dragging && !Live) Move(); // Redraw the window in the final position.
  Dragging=false;
}

void CDragBar::OnCaptureChanged(CWnd *pWnd) {
  Release();
  Finish();
	CWnd::OnCaptureChanged(pWnd);
}

void CDragBar::Move(int dx /* =0 */) {
  CRect Rect;
  GetParent()->GetClientRect(&Rect);
  int ParentWidth=Rect.Width();
  GetWindowRect(&Rect);
  GetParent()->ScreenToClient(&Rect);
  Position=double(Rect.left+dx)/ParentWidth;
  OnMove();
}

void CDragBar::OnPaint() {
	CPaintDC dc(this); // device context for painting
  CRect Rect;
  GetClientRect(&Rect);
  Rect.bottom-=2;
	dc.Draw3dRect(2,1,3,Rect.bottom,GetSysColor(COLOR_3DHILIGHT),GetSysColor(COLOR_3DSHADOW));
	dc.Draw3dRect(6,1,3,Rect.bottom,GetSysColor(COLOR_3DHILIGHT),GetSysColor(COLOR_3DSHADOW));
}
