// DragBarTesterDlg.cpp

#include "stdafx.h"
#include "DragBarTester.h"
#include "DragBarTesterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDragBarTesterDlg::CDragBarTesterDlg(CWnd* pParent /*=NULL*/)	: CDialog(CDragBarTesterDlg::IDD, pParent) {
	//{{AFX_DATA_INIT(CDragBarTesterDlg)
	//}}AFX_DATA_INIT
  Updated=false;
}

BEGIN_MESSAGE_MAP(CDragBarTesterDlg, CDialog)
	//{{AFX_MSG_MAP(CDragBarTesterDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_Live, OnLive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDragBarTesterDlg::OnInitDialog() {
	CDialog::OnInitDialog();

  DragBar.SubclassDlgItem(IDC_DragBar,this);
  DragBar.SetDefault(0.3);
  DragBar.SetLive(false);
  Updated=true;
  DragBar.Move();

  CheckDlgButton(IDC_Live,1);
  OnLive();

  return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDragBarTesterDlg::OnOK() {}
void CDragBarTesterDlg::OnLive() {DragBar.SetLive(IsDlgButtonChecked(IDC_Live)!=0);}

void CDragBarTesterDlg::OnSize(UINT nType, int cx, int cy) {
	CDialog::OnSize(nType, cx, cy);
  if(!Updated) return; // Don't access windows before they've been created
//  if(nType!=SIZE_BAR_DRAGGED) return; // Uncomment this if you don't want windows moving while resizing.
  const int m = 3; // Small Margin
  const int M = 6; // Big Margin
  const int MH=50; // Menu Height
  const int LH=60; // List Height
  CRect Rect;
  GetClientRect(&Rect);
  int WR=Rect.Width();
  int H=Rect.Height();
  int L=DragBar.GetPosition(Rect.Width()); // Left of the DragBar
  const int W=DragBar.Width;
  int R=Rect.Width()-L;         // (  x,         y,    cx,        cy)
  GetDlgItem(IDC_EDIT1)->MoveWindow(  m,   MH   +m,   L-m, H-MH   -M);
  DragBar.               MoveWindow(L  ,   MH   +m,     W, H-MH   -M);
  GetDlgItem(IDC_EDIT2)->MoveWindow(L+W,   MH   +m, R-W-m, H-MH-LH-M); //x,y,dx,dy
  GetDlgItem(IDC_LIST1)->MoveWindow(L+W, H   -LH-m, R-W-m,      LH  );
  GetDlgItem(IDC_LIST1)->RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW); // Listboxes don't redraw their background even when MoveWindow invalidates them!
  GetDlgItem(IDC_TEXT1)->GetWindowRect(&Rect); // Now keep the text full width:
  ScreenToClient(&Rect);
  Rect.right=WR;
  GetDlgItem(IDC_TEXT1)->MoveWindow(&Rect); // This redraws the border but we have to redraw the rest ourselves:
  GetDlgItem(IDC_TEXT1)->RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW); // Statics don't redraw their full text even when MoveWindow invalidates them!
}
